/*
	File : 2D_fft.c
*/

/* --- vO̐ ---
@4oCg̒Px_^2摜t@C͂āC
FFTgĂQt[GϊvOD

́F
  1D̓̓t@CiPx_^j
  2D̓̓t@CiPx_^j
     i"0image"Ɠ͂Ƌf[^ׂ͂0ɐݒ肳j
  3D̏o̓t@CiPx_^j
  4D̏o̓t@CiPx_^j
  5Dx̃}gNXTCYi2̃xLj
  6Dỹ}gNXTCYi2̃xLj
  7DϊƋtϊ̃XCb`i1FϊC-1Ftϊj

óF
  Qt[GϊƋ̃t@C

Kvȃt@CF
  io.c        i摜̓o͊֐̃t@Cj
  fft.c       i1,2,3FFT֐̃t@Cj

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PN  8

typedef struct {
	char   f1[50]; /* input real file name */
	char   f2[50]; /* input imaginary file name */
	char   f3[50]; /* output real file name */
	char   f4[50]; /* output imaginary file name */
	int    nx;     /* number of matrix (x) */
	int    ny;     /* number of matrix (y) */
	int    ir;     /* forward or inverse */
} Param;

char *menu[PN] = {
	"Calculation 2D-FFT",
	"Input  real      file name <float> ",
	"Input  imaginary file name <float> ",
	"Output real      file name <float> ",
	"Output imaginary file name <float> ",
	"Number of matrix  (x)    ",
	"Number of matrix  (y)    ",
	"Forward(1) or Inverse(-1)",
	};

void read_data(char *, float *, int);
void write_data(char *, float *, int);
void FFT_2D(int, float *, float *, int, int);
void FFTInit(int, float *, float *, unsigned short *);
void FFT(int, int, float *, float *, float *, float *,unsigned short *);

void usage(int argc, char **argv)
{
	int   i;

	fprintf( stderr,"\nUSAGE:\n");
	fprintf( stderr,"\nNAME\n");
	fprintf( stderr,"\n  %s - %s\n", argv[0], menu[0]);
	fprintf( stderr,"\nSYNOPSIS\n");
	fprintf( stderr,"\n  %s [-h] parameters...\n", argv[0]);
	fprintf( stderr,"\nPARAMETERS\n");
	for(i = 1 ; i < PN ; i++)
	  fprintf( stderr,"\n %3d. %s\n", i, menu[i]);
	fprintf( stderr,"\n");
	fprintf( stderr,"\nFLAGS\n");
	fprintf( stderr,"\n  -h  Print Usage (this comment).\n");
	fprintf( stderr,"\n");
	exit(1);
}

void getparameter(int argc, char **argv, Param *pm)
{
	int   i;
	char  dat[256];

	/* default parameter value */
	sprintf( pm->f1, "n0.img");
	sprintf( pm->f2, "0image");
	sprintf( pm->f3, "n1.img");
	sprintf( pm->f4, "n2.img");
	pm->nx = 128;
	pm->ny = 128;
	pm->ir = 1;

	i = 0;
	if( argc == 1+i ) {
		fprintf( stdout, "\n%s\n\n", menu[i++] );
		fprintf( stdout, " %s [%s] :", menu[i++], pm->f1 );
		if(*gets(dat) != '\0')  strcpy(pm->f1, dat);
		fprintf( stdout, " %s [%s] :", menu[i++], pm->f2 );
		if(*gets(dat) != '\0')  strcpy(pm->f2, dat);
		fprintf( stdout, " %s [%s] :", menu[i++], pm->f3 );
		if(*gets(dat) != '\0')  strcpy(pm->f3, dat);
		fprintf( stdout, " %s [%s] :", menu[i++], pm->f4 );
		if(*gets(dat) != '\0')  strcpy(pm->f4, dat);
		fprintf( stdout, " %s [%i] :", menu[i++], pm->nx );
		if(*gets(dat) != '\0')  pm->nx = atoi(dat);
		fprintf( stdout, " %s [%i] :", menu[i++], pm->ny );
		if(*gets(dat) != '\0')  pm->ny = atoi(dat);
		fprintf( stdout, " %s [%i] :", menu[i++], pm->ir );
		if(*gets(dat) != '\0')  pm->ir = atoi(dat);
	}
	else if ( argc == PN+i ) {
		fprintf( stderr, "\n%s [%s]\n", argv[i++], menu[0] );
		if((argc--) > 1) strcpy( pm->f1, argv[i++] );
		if((argc--) > 1) strcpy( pm->f2, argv[i++] );
		if((argc--) > 1) strcpy( pm->f3, argv[i++] );
		if((argc--) > 1) strcpy( pm->f4, argv[i++] );
		if((argc--) > 1) pm->nx = atoi( argv[i++] );
		if((argc--) > 1) pm->ny = atoi( argv[i++] );
		if((argc--) > 1) pm->ir = atoi( argv[i++] );
	}
	else {
		usage(argc, argv);
	}
}

void main(int argc, char *argv[] )
{
	int     i;
	Param   *pm;
	float   *imgr, *imgi;

	pm = (Param *)malloc(sizeof(Param));
	getparameter(argc, argv, pm);

	imgr = (float *)malloc((unsigned long)pm->nx*pm->ny*sizeof(float));
	imgi = (float *)malloc((unsigned long)pm->nx*pm->ny*sizeof(float));

	printf(" *** Read Image data   ***\n");
	read_data(pm->f1, imgr, pm->nx*pm->ny);
	if(strcmp(pm->f2, "0image"))
		read_data(pm->f2, imgi, pm->nx*pm->ny);
	else
		for(i = 0 ; i < pm->nx*pm->ny ; i++)
			imgi[i] = 0;

	printf(" *** Calculation 2D-FFT  ***\n");
	FFT_2D(pm->ir, imgr, imgi, pm->nx, pm->ny);

	printf(" *** Write Image data   ***\n");
	write_data(pm->f3, imgr, pm->nx*pm->ny);
	write_data(pm->f4, imgi, pm->nx*pm->ny);

	free(imgr);
	free(imgi);
	free(pm);
}
