/*
	File : addnoise.c
*/

/* --- vO̐ ---

11́@MRIč\摜ւ̃mCỶe

@MRǏvf[^͂āCGtvOD
@ǴCKEXGƈlGIłD

́F
  1DMRIf[^̎̃t@CiPx_^j
  2DMRIf[^̋̃t@CiPx_^j
  3DmCY܂񂾏o̓f[^̎̃t@CiPx_^j
  4DmCY܂񂾏o̓f[^̋̃t@CiPx_^j
  5D摜x̃}gNXTCYi2̃xLj
  6D摜ỹ}gNXTCYi2̃xLj
  7DmCY̋xidBj
  8DG̎ށiKEXGF0ClGF1j
  9. G̃p^[iꍇ͓Gj

óF
  mCY܂񂾃f[^̎̉摜
  mCY܂񂾃f[^̋̉摜

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PN 10

typedef struct {
	char    f1[50]; /* output file name */
	char    f2[50]; /* output file name */
	char    f3[50]; /* output file name */
	char    f4[50]; /* output file name */
	float   *img;   /* real part */
	float   *imi;   /* imaginary part */
	int     nx;     /* number of matrix (x) */
	int     ny;     /* number of matrix (y) */
	double  db;     /* noise power */
	int     nt;     /* noise types */
	int     np;     /* noise pattern */
	double  a1;     /* uniform random variable start point */
	double  a2;     /* uniform random variable end point */
	double  max;    /* maximum value */
} Param;

char *menu[PN] = {
	"add noise image",
	"Input  file name re <float>  ",
	"Input  file name im <float>  ",
	"Output file name re <float>  ",
	"Output file name im <float>  ",
	"Number of matrix  (x)    ",
	"Number of matrix  (y)    ",
	"Noise power (dB)         ",
	"Noise types   (Gaussian:0, Uniformity:1) ",
	"Noise pattern (0, 1, 2, ...  -> Integer) ",
	};

void read_data(char *, float *, int);
void write_data(char *, float *, int);
void noise_initialize(int, int);
void addnoise_gaussian(float *, int, double);
void addnoise_uniformity(float *, int, double, double);
double fdmax(float *, int, double);

void usage(int argc, char **argv)
{
	int   i;

	fprintf( stderr,"\nUSAGE:\n");
	fprintf( stderr,"\nNAME\n");
	fprintf( stderr,"\n  %s - %s\n", argv[0], menu[0]);
	fprintf( stderr,"\nSYNOPSIS\n");
	fprintf( stderr,"\n  %s [-h] parameters...\n", argv[0]);
	fprintf( stderr,"\nPARAMETERS\n");
	for(i = 1 ; i < PN ; i++)
	  fprintf( stderr,"\n %3d. %s\n", i, menu[i]);
	fprintf( stderr,"\n");
	fprintf( stderr,"\nFLAGS\n");
	fprintf( stderr,"\n  -h  Pring Usage (this comment).\n");
	fprintf( stderr,"\n");
	exit(1);
}

void getparameter(int argc, char **argv, Param *pm)
{
	int   i;
	char  dat[100];

	/* default parameter value */
	sprintf( pm->f1, "sr.img");
	sprintf( pm->f2, "si.img");
	sprintf( pm->f3, "srn40.img");
	sprintf( pm->f4, "sin40.img");
	pm->nx = 256;
	pm->ny = 256;
	pm->db = 40.0;        // 40 dB
	pm->nt = 0;           // Gaussian noise
	pm->np = 0;           // noise pattern
	pm->a1 = -sqrt(3.0);  // Uniformity noise sd = (a2-a1)/(2*sqrt(3.0))
	pm->a2 =  sqrt(3.0);  //                  sd = 1.0
	pm->max = 0;          // maximum value of images (real & imaginary)

	i = 0;
	if( argc == 1+i ) {
		fprintf( stdout, "\n%s\n\n", menu[i++] );
		fprintf( stdout, " %s [%s] :", menu[i++], pm->f1 );
		if(*gets(dat) != '\0')  strcpy(pm->f1, dat);
		fprintf( stdout, " %s [%s] :", menu[i++], pm->f2 );
		if(*gets(dat) != '\0')  strcpy(pm->f2, dat);
		fprintf( stdout, " %s [%s] :", menu[i++], pm->f3 );
		if(*gets(dat) != '\0')  strcpy(pm->f3, dat);
		fprintf( stdout, " %s [%s] :", menu[i++], pm->f4 );
		if(*gets(dat) != '\0')  strcpy(pm->f4, dat);
		fprintf( stdout, " %s [%d] :", menu[i++], pm->nx );
		if(*gets(dat) != '\0')  pm->nx = atoi(dat);
		fprintf( stdout, " %s [%d] :", menu[i++], pm->ny );
		if(*gets(dat) != '\0')  pm->ny = atoi(dat);
		fprintf( stdout, " %s [%f] :", menu[i++], pm->db );
		if(*gets(dat) != '\0')  pm->db = atof(dat);
		fprintf( stdout, " %s [%d] :", menu[i++], pm->nt );
		if(*gets(dat) != '\0')  pm->nt = atoi(dat);
		fprintf( stdout, " %s [%d] :", menu[i++], pm->np );
		if(*gets(dat) != '\0')  pm->np = atoi(dat);
	}
	else if ( argc == PN+i ) {
		fprintf( stderr, "\n%s [%s]\n", argv[i++], menu[0] );
		if((argc--) > 1) strcpy( pm->f1, argv[i++] );
		if((argc--) > 1) strcpy( pm->f2, argv[i++] );
		if((argc--) > 1) strcpy( pm->f3, argv[i++] );
		if((argc--) > 1) strcpy( pm->f4, argv[i++] );
		if((argc--) > 1) pm->nx = atoi( argv[i++] );
		if((argc--) > 1) pm->ny = atoi( argv[i++] );
		if((argc--) > 1) pm->db = atof( argv[i++] );
		if((argc--) > 1) pm->nt = atoi( argv[i++] );
		if((argc--) > 1) pm->np = atoi( argv[i++] );
	}
	else {
		usage(argc, argv);
	}
}

void main(int argc, char *argv[] )
{
	Param   *pm;

	pm = (Param *)malloc(sizeof(Param));
	getparameter(argc, argv, pm);

	pm->img = (float *)malloc((unsigned long)pm->nx*pm->ny*sizeof(float));
	pm->imi = (float *)malloc((unsigned long)pm->nx*pm->ny*sizeof(float));

	printf(" *** Read Image data   ***\n");
	read_data(pm->f1, pm->img, pm->nx*pm->ny);
	read_data(pm->f2, pm->imi, pm->nx*pm->ny);

	// 摜Ƌ摜̍ől߂
	pm->max = fdmax(pm->img, pm->nx*pm->ny, pm->max);
	pm->max = fdmax(pm->imi, pm->nx*pm->ny, pm->max);

	// 摜̍őlƃmCYxmCYSD߂
	pm->max *= pow(0.1, pm->db/10.0);
	fprintf(stderr, "SD of noise : %f\n", pm->max);

	// mCY̏imCYp^[ωj
	noise_initialize(pm->np, pm->nx*pm->ny);

	switch(pm->nt) {
	case 0:
		printf(" *** Add Gaussian Noise to Image data   ***\n");
		addnoise_gaussian(pm->img, pm->nx*pm->ny, pm->max);
		addnoise_gaussian(pm->imi, pm->nx*pm->ny, pm->max);
		break;
	default:
		printf(" *** Add Uniformity Noise to Image data   ***\n");
		pm->a1 *= pm->max; // lG̍ŏl
		pm->a2 *= pm->max; // lG̍ől
		addnoise_uniformity(pm->img, pm->nx*pm->ny, pm->a1, pm->a2);
		addnoise_uniformity(pm->imi, pm->nx*pm->ny, pm->a1, pm->a2);
	}

	printf(" *** Write Image data   ***\n");
	write_data(pm->f3, pm->img, pm->nx*pm->ny);
	write_data(pm->f4, pm->imi, pm->nx*pm->ny);

	free(pm->img);
	free(pm->imi);
}

void read_data(char *fi, float *img, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "rb")) == NULL) {
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

void write_data(char *fi, float *img, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL) {
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}

void noise_initialize(int np, int n)
{
	int    i, j;
	long   idum=999;
	float  ran1(long *);
	
	for(i = 0 ; i < np ; i++)
		for(j = 0 ; j < n ; j++)
			ran1(&idum);
}

void addnoise_gaussian(float *img, int n, double a)
// KEXGt֐
// float  *img; Gt摜
// int    n;    摜̉f
// double a;    G̕W΍iSDj
{
	int     i;
	long    idum=999;
	double  noi, sum, sum2, ave, var, sd;
	float	gasdev(long *);

	sum2 = sum = 0;
	for(i = 0 ; i < n ; i++) {
		noi = a*gasdev(&idum);
		img[i] += (float)noi;
		sum  += noi;
		sum2 += noi*noi;
	}
	ave = sum/n;
	var = (sum2-ave*ave)/n;
	sd = sqrt(var);
	fprintf(stderr, "average=%f, variance=%f, sd=%f\n", ave, var, sd);
}

void addnoise_uniformity(float *img, int n, double a1, double a2)
// lGt֐
// float  *img; Gt摜
// int    n;    摜̉f
// double a1;   G̍ŏl
// double a2;   G̍ől
{
	int     i;
	long    idum=999;
	double  noi, sum, sum2, ave, var, sd;
	float	ran1(long *);

	sum2 = sum = 0;
	for(i = 0 ; i < n ; i++) {
		noi = (a2-a1)*ran1(&idum)+a1;
		img[i] += (float)noi;
		sum  += noi;
		sum2 += noi*noi;
	}
	ave = sum/n;
	var = (sum2-ave*ave)/n;
	sd = sqrt(var);
	fprintf(stderr, "average=%f, variance=%f, sd=%f\n", ave, var, sd);
}

double fdmax(float *img, int n, double max)
// 摜̍ől߂֐
// float  *img; ől߂摜
// int    n;    摜̉f
// double max;  ől̏l
{
	int  i;

	for(i = 0 ; i < n ; i++) {
		if(max < (double)img[i]) max = img[i];
	}
	fprintf(stderr, "max = %f\n", max);
	return  max; // ߂őlԂ
}

/*
	Random Function
	(QlFNUMERICAL RECIPES in C)
*/

#define	IA		16807
#define	IM		2147483647
#define	AM		(1.0/IM)
#define	IQ		127773
#define	IR		2836
#define	NTAB	32
#define	NDIV	(1+(IM-1)/NTAB)
#define	EPS		1.2e-7
#define	RNMX	(1.0-EPS)

float	ran1(long *idum)
/* random number {0.0,1.0}
   initialize    *idum < 0  ( Don't change.)
*/
{
	int			j;
	long		k;
	static long	iy=0;
	static long	iv[NTAB];
	float		temp;
	
	/* initialization */
	if(*idum <= 0 || !iy) {
		if(-(*idum) < 1)	*idum = 1;
		else				*idum = -(*idum);
		for(j=NTAB+7;j>=0;j--) {
			k = (*idum)/IQ;
			*idum = IA*(*idum-k*IQ)-IR*k;
			if(*idum < 0)	*idum += IM;
			if(j < NTAB)	iv[j] = *idum;
		}
		iy = iv[0];
	}
	
	/* create random number */
	k = (*idum)/IQ;
	*idum = IA*(*idum-k*IQ)-IR*k;
	if(*idum < 0)	*idum += IM;
	j = iy/NDIV;
	iy = iv[j];
	iv[j] = *idum;
	if((temp=AM*iy) > RNMX)		return RNMX;
	else						return temp;
}

float gasdev(long *idum)
/*
	Gaussian noise (average:0, variance:1)
*/
{
	float  ran1(long *);
	static int iset=0;
	static float gset;
	float  fac, rsq, v1, v2;

	if(iset == 0) {
		do {
			v1 = 2.0*ran1(idum)-1.0;
			v2 = 2.0*ran1(idum)-1.0;
			rsq = v1*v1+v2*v2;
		} while (rsq >= 1.0 || rsq == 0.0);
		fac = sqrt(-2.0*log(rsq)/rsq);
		gset = v1*fac;
		iset = 1;
		return  v2*fac;
	}
	else {
		iset = 0;
		return gset;
	}
}
