/*
	File : fft.c
*/

/* --- vO̐ ---

1FFT֐it[Gϊj
2FFT֐it[Gϊj
3FFT֐it[Gϊj

̃vOgƂ́C5̔zpӂĂD
xr[xn]    : 1t[Gϊp̎f[^
xi[xn]    : 1t[Gϊp̋f[^
si[xn]    : t[GϊŎgTCf[^
co[xn]    : t[GϊŎgRTCf[^
brv[xn/2] : t[GϊŎgo^tCZf[^

nx        : 1t[Gϊ̃f[^i2̃xLj

֐F
void FFTInit(int nx, float *si, float *co, unsigned short *brv)
  t[GϊɕKvȃTCƃRTCƃo^tCZf[^쐬֐D
  FFT֐gOɁC1xgpĕKvȃf[^쐬D
  int    nx;  // FFT̃f[^
  float *si;  // TCf[^iz̃|C^j
  float *co;  // RTCf[^iz̃|C^j
  unsigned short *brv; // o^tCZf[^iz̃|C^j

void FFT(int ir, int nx, float *xr, float *xi, float *si, float *co, unsigned short *brv)
  1t[Gϊs֐D
  TCCRTCCo^tCZf[^́CFFTInit֐ō쐬̂gpD
  int    ir;  // ϊ(1)Ƌtϊ(-1)
  int    nx;  // FFT̃f[^i2̃xLj
  float *xr;  // FFTf[^iz̃|C^j
  float *xi;  // FFT鋕f[^iz̃|C^j
  float *si;  // TCf[^iz̃|C^j
  float *co;  // RTCf[^iz̃|C^j
  unsigned short *brv; // o^tCZf[^iz̃|C^j

void FFT_2D(int ir, float *img, float *imi, int nx, int ny)
@2t[Gϊs֐D
  int    ir;  // ϊ(1)Ƌtϊ(-1)
  float *img; // FFTf[^iz̃|C^j
  float *imi; // FFT鋕f[^iz̃|C^j
  int    nx;  // FFTx̃f[^i2̃xLj
  int    ny;  // FFTỹf[^i2̃xLj

void FFT_3D(int ir, float *img, float *imi, int nx, int ny, int nz)
@3t[Gϊs֐D
  int    ir;  // ϊ(1)Ƌtϊ(-1)
  float *img; // FFTf[^iz̃|C^j
  float *imi; // FFT鋕f[^iz̃|C^j
  int    nx;  // FFTx̃f[^i2̃xLj
  int    ny;  // FFTỹf[^i2̃xLj
  int    nz;  // FFTz̃f[^i2̃xLj

*/

#include    <stdio.h>
#include    <stdlib.h>
#include	<math.h>
#define   PI  3.14159265358979


void bitrev(int nx, float *xr, float *xi, unsigned short *brv)
{
	int     i, j;
	float   a, b;
	for(i = 0; i < nx; i++){
	    j = brv[i];
	    if(i < j){
	        a = xr[i];
	        b = xi[i];
	        xr[i] = xr[j];
	        xi[i] = xi[j];
	        xr[j] = a;
	        xi[j] = b;
	    }
	}
}


void FFT(int ir, int nx, float *xr, float *xi, float *si, float *co, unsigned short *brv)
{
	int     i, j, n1, n2=nx, j3, j4, k, l, ll, d=1, g;
	float   a, b, c, s;

	for(l = 1; l <= nx/2; l *= 2, d += d) {
	    g  = 0;
	    ll = n2;
	    n2 /= 2;
	    for(k = 1; k <= n2; k++) {
	        n1 = k-ll;
	        c  = co[g];
	        s  = -ir*si[g];
	        g += d;
	        for(j = ll; j <= nx; j += ll) {
	            j3 = j+n1-1;
	            j4 = j3+n2;
	            a  = xr[j3]-xr[j4];
	            b  = xi[j3]-xi[j4];
	            xr[j3] += xr[j4];  xi[j3] += xi[j4];
	            xr[j4] =  c*a+s*b; xi[j4] =  c*b-s*a;
	        }
	    }
	}

	bitrev(nx, xr, xi, brv);
	if(ir == -1)
	    for(i = 0; i < nx; i++) {
	        xr[i] /= nx;
	        xi[i] /= nx;
	    }
}

int br(int nx, unsigned nn)
{
	unsigned        r,c;
	r=0;
	for(c=1;c<=(unsigned)nx/2;c<<=1){
	    r<<=1;
	    if((nn&c)!=0)
	         r++;
	}
	return(r);
}


void FFTInit(int nx, float *si, float *co, unsigned short *brv)
{
	double  d=2.0*PI/nx;
	int     i;
	int     br(int, unsigned);
	for(i = 0; i < nx/4; i++) {
	    si[i] = (float)sin(d*i);
	    co[i+nx/4] = -si[i];
	}
	for(i = nx/4; i < nx/2; i++) {
	    si[i] = (float)sin(d*i);
	    co[i-nx/4] = si[i];
	}
	for(i = 0; i < nx; i++)
	    brv[i] = br(nx, (unsigned)i);
}


void fswap(float *s1, float *s2)
// 2̕ϐl̃Xbv()
{
	float  ss;
	ss  = *s1;
	*s1 = *s2;
	*s2 = ss;
}

void fswap_2D(float *img, int nx, int ny)
// 2FFTpf[^̓ւ
{
	int   i, j;
	void  fswap(float *, float *);

	for(i = 0 ; i < ny ; i++) {
		for(j = 0 ; j < nx/2 ; j++) {
			fswap(&img[i*nx+j], &img[i*nx+j+nx/2]);
		}
	}
	for(i = 0 ; i < nx ; i++) {
		for(j = 0 ; j < ny/2 ; j++) {
			fswap(&img[j*nx+i], &img[(j+ny/2)*nx+i]);
		}
	}
}

void FFT_2D(int ir, float *img, float *imi, int nx, int ny)
// 2t[Gϊ
{
	int     i, j;
	float   *xr, *xi, *si, *co;
	unsigned short *br;
	void    fswap_2D(float *, int, int);


	fswap_2D(img, nx, ny);
	fswap_2D(imi, nx, ny);
//	write_data("swap_r.img", img, nx*ny);

	xr = (float *)malloc((unsigned long)nx*sizeof(float));
	xi = (float *)malloc((unsigned long)nx*sizeof(float));
	si = (float *)malloc((unsigned long)nx*sizeof(float));
	co = (float *)malloc((unsigned long)nx*sizeof(float));
	br = (unsigned short *)malloc((unsigned long)nx*sizeof(unsigned short));
	FFTInit(nx, si, co, br);
	for(i = 0 ; i < ny ; i++) {
		for(j = 0 ; j < nx ; j++){
			xr[j] = img[i*nx+j];
			xi[j] = imi[i*nx+j];
		}
		FFT(ir, nx, xr, xi, si, co, br);
		for(j = 0 ; j < nx ; j++){
			img[i*nx+j] = xr[j];
			imi[i*nx+j] = xi[j];
		}
	}
	free(xr);
	free(xi);
	free(si);
	free(co);
	free(br);
//	write_data("fft_1r.img", img, nx*ny);

	xr = (float *)malloc((unsigned long)ny*sizeof(float));
	xi = (float *)malloc((unsigned long)ny*sizeof(float));
	si = (float *)malloc((unsigned long)ny*sizeof(float));
	co = (float *)malloc((unsigned long)ny*sizeof(float));
	br = (unsigned short *)malloc((unsigned long)ny*sizeof(unsigned short));
	FFTInit(ny, si, co, br);
	for(i = 0 ; i < nx ; i++) {
		for(j = 0 ; j < ny ; j++){
			xr[j] = img[j*nx+i];
			xi[j] = imi[j*nx+i];
		}
		FFT(ir, ny, xr, xi, si, co, br);
		for(j = 0 ; j < ny ; j++){
			img[j*nx+i] = xr[j];
			imi[j*nx+i] = xi[j];
		}
	}
	free(xr);
	free(xi);
	free(si);
	free(co);
	free(br);

//	write_data("swap_f.img", img, nx*ny);
	fswap_2D(img, nx, ny);
	fswap_2D(imi, nx, ny);
}


void FFT_3D(int ir, float *img, float *imi, int nx, int ny, int nz)
// 3t[Gϊ
{
	int     i, j, k;
	float   *xr, *xi, *si, *co;
	unsigned short *br;

// x-direction
	printf(" >>> FFT x-direction <<< ");
	xr = (float *)malloc((unsigned long)nx*sizeof(float));
	xi = (float *)malloc((unsigned long)nx*sizeof(float));
	si = (float *)malloc((unsigned long)nx*sizeof(float));
	co = (float *)malloc((unsigned long)nx*sizeof(float));
	br = (unsigned short *)malloc((unsigned long)nx*sizeof(unsigned short));
	FFTInit(nx, si, co, br);
	for(i = 0 ; i < ny*nz ; i++) {
		for(j = 0 ; j < nx/2 ; j++){
			xr[j+nx/2] = img[i*nx+j];
			xr[j] = img[i*nx+j+nx/2];
			xi[j+nx/2] = imi[i*nx+j];
			xi[j] = imi[i*nx+j+nx/2];
		}
		FFT(ir, nx, xr, xi, si, co, br);
		for(j = 0 ; j < nx/2 ; j++){
			img[i*nx+j] = xr[j+nx/2];
			img[i*nx+j+nx/2] = xr[j];
			imi[i*nx+j] = xi[j+nx/2];
			imi[i*nx+j+nx/2] = xi[j];
		}
	}
	free(xr);
	free(xi);
	free(si);
	free(co);
	free(br);

// y-direction
	printf("\n >>> FFT y-direction <<< ");
	xr = (float *)malloc((unsigned long)ny*sizeof(float));
	xi = (float *)malloc((unsigned long)ny*sizeof(float));
	si = (float *)malloc((unsigned long)ny*sizeof(float));
	co = (float *)malloc((unsigned long)ny*sizeof(float));
	br = (unsigned short *)malloc((unsigned long)ny*sizeof(unsigned short));
	FFTInit(ny, si, co, br);
	for(k = 0 ; k < nz ; k++) {
		for(i = 0 ; i < nx ; i++) {
			for(j = 0 ; j < ny/2 ; j++){
				xr[j+ny/2] = img[k*nx*ny+j*nx+i];
				xr[j] = img[k*nx*ny+(j+ny/2)*nx+i];
				xi[j+ny/2] = imi[k*nx*ny+j*nx+i];
				xi[j] = imi[k*nx*ny+(j+ny/2)*nx+i];
			}
			FFT(ir, ny, xr, xi, si, co, br);
			for(j = 0 ; j < ny/2 ; j++){
				img[k*nx*ny+j*nx+i] = xr[j+ny/2];
				img[k*nx*ny+(j+ny/2)*nx+i] = xr[j];
				imi[k*nx*ny+j*nx+i] = xi[j+ny/2];
				imi[k*nx*ny+(j+ny/2)*nx+i] = xi[j];
			}
		}
	}
	free(xr);
	free(xi);
	free(si);
	free(co);
	free(br);

// z-direction
	printf("\n >>> FFT z-direction <<< ");
	xr = (float *)malloc((unsigned long)nz*sizeof(float));
	xi = (float *)malloc((unsigned long)nz*sizeof(float));
	si = (float *)malloc((unsigned long)nz*sizeof(float));
	co = (float *)malloc((unsigned long)nz*sizeof(float));
	br = (unsigned short *)malloc((unsigned long)nz*sizeof(unsigned short));
	FFTInit(nz, si, co, br);
	for(j = 0 ; j < ny ; j++){
		for(i = 0 ; i < nx ; i++) {
			for(k = 0 ; k < nz/2 ; k++) {
				xr[k+nz/2] = img[k*nx*ny+j*nx+i];
				xr[k] = img[(k+nz/2)*nx*ny+j*nx+i];
				xi[k+nz/2] = imi[k*nx*ny+j*nx+i];
				xi[k] = imi[(k+nz/2)*nx*ny+j*nx+i];
			}
			FFT(ir, nz, xr, xi, si, co, br);
			for(k = 0 ; k < nz/2 ; k++){
				img[k*nx*ny+j*nx+i] = xr[k+nz/2];
				img[(k+nz/2)*nx*ny+j*nx+i] = xr[k];
				imi[k*nx*ny+j*nx+i] = xi[k+nz/2];
				imi[(k+nz/2)*nx*ny+j*nx+i] = xi[k];
			}
		}
	}
	free(xr);
	free(xi);
	free(si);
	free(co);
	free(br);
	printf("\n");

}

void  data_max(float *img, int size, int number)
{
	int    i, j;
	float  max;

	for(i = 0 ; i < number ; i++) {
		if(i%20 == 0) getchar();
		max = img[i*size];
		for(j = 1 ; j < size ; j++) {
			max = max > img[i*size+j] ? max : img[i*size+j];
		}
		printf(" max[%3d] = %f \n", i, max);
	}
}
